#version 330

in vec3 InVertex;
in vec2 InTexCoord;

in vec3 InNormal;
in vec3 InTangent;
in vec3 InBitangent; //Not Needed?

out vec2 texCoord;

out vec3 N;
out vec3 V;
out vec3 L;

out vec3 T; //Tangent
out vec3 B; //Bitangent

out vec3 WorldPos; //required for shadow mapping

uniform int point_light_size;
uniform vec3 point_light_vec[32];
uniform mat4 ModelViewProjectionMatrix;
uniform mat4 ModelMatrix;
//uniform mat4 ModelViewMatrix;

//uniform mat3 NormalMatrix; only need when non uniform scaling is used
uniform vec3 InView; //View Vector = CameraLocation.

void main()
{
	WorldPos = InVertex;
	gl_Position = ModelViewProjectionMatrix * vec4(InVertex, 1.0);
	
	N = vec3(ModelMatrix * vec4(InNormal, 0));
	T = vec3(ModelMatrix * vec4(InTangent, 0));
	B = vec3(ModelMatrix * vec4(InBitangent,0));
	//B = cross(N, T);

	V = InView - vec3(ModelMatrix * vec4(InVertex, 1.0));

	texCoord = InTexCoord;
}