#version 330

uniform mat4 ViewMatrix;
uniform float Stretch; //defines how much the moving speed stretches the particle
uniform float Size; // the width of the particle

struct Particle
{
	vec3 position;
	vec4 color;
	vec3 velocity;
	float lifetime;
};

in vec3 InPosition;
in vec4 InColor;
in vec3 InVelocity;
in float InLifetime;

out vec2 NormalDir;
out vec2 StretchDir;
out vec4 Color;
out vec4 Position;

void main()
{
	Position = ViewMatrix * vec4(InPosition, 1.0);
	gl_Position = Position;
	vec2 Dir = (ViewMatrix * vec4(InVelocity, 0.0)).xy;
	NormalDir = normalize(Dir) * Size;
	StretchDir = NormalDir + Dir * Stretch;
	NormalDir = NormalDir.yx;
	NormalDir.y = -NormalDir.y;
	Color = InColor;
}