#version 330

uniform mat4 ProjectionMatrix;

layout (points) in;
layout (triangle_strip, max_vertices = 4) out;

in vec2 NormalDir[];
in vec2 StretchDir[];
in vec4 Color[];
in vec4 Position[];

out vec2 TexCoord;
out vec4 TexColor;

void main()
{
	vec4 sd = vec4(StretchDir[0], 0.0, 0.0);
	vec4 nd = vec4(NormalDir[0], 0.0, 0.0);

	TexColor = Color[0];

	TexCoord = vec2(0.0, 0.0);
	vec4 pos = Position[0] - sd / 2 - nd / 2;
	gl_Position = ProjectionMatrix * pos;
	EmitVertex();
	TexCoord = vec2(1.0f, 0.0f);
	pos += nd;
	gl_Position = ProjectionMatrix * pos;
	EmitVertex();
	TexCoord = vec2(0.0f, 1.0f);
	pos += sd - nd;
	gl_Position = ProjectionMatrix * pos;
	EmitVertex();
	TexCoord = vec2(1.0f, 1.0f);
	pos += nd;
	gl_Position = ProjectionMatrix * pos;
	EmitVertex();
	EndPrimitive();
}