#version 410

in vec3 InPosition;

in vec3 InN;
in vec3 InT;
in vec3 InB;

in float InFactor1;
in float InFactor2;

in vec3 InTexMapPos;

out vec3 WorldPos;

out vec3 N;
out vec3 T; //Tangent
out vec3 B; //Bitangent

out vec3 V;

out float factor1;
out float factor2;

out vec3 TexMapPos;

//out vec4 ShadowCoord;


uniform mat4 ModelViewProjectionMatrix;
//uniform mat4 depthMVP[4];
//uniform float splitD[4];
uniform vec3 InViewModel; //eye pos in model coordinates (for lighting)
uniform float modelScaling;


void main() {
	V = InViewModel - InPosition;

	WorldPos = InPosition;
	
	//SHADOW MAPPING
	//ShadowCoord = depthMVP[1] * vec4(InPosition, 1.0); //moved to frag
	
	gl_Position = ModelViewProjectionMatrix * vec4(InPosition, 1.0);


	//pass through

	N = InN;
	T = InT;
	B = InB;
	factor1 = InFactor1;
	factor2 = InFactor2;
	TexMapPos = InTexMapPos;
}
