#version 410 core

in vec2 InVertex;

uniform sampler2D heightMap;
uniform float heightScaling;

void main()
{
	//set gl_Position to the correct heights - all in model space
	//this is needed for culling in the tcs shader
	float height = texture2D(heightMap, vec2(InVertex.x, 1.0 - InVertex.y)).r * heightScaling;
	gl_Position = vec4(InVertex.x, height, InVertex.y, 1.0);
}
